# ni li ken pakala. mi pana e jaki ala.
# musi ni li jaki, sina wile ala e jaki ante.

def sike_ante(nanpa):
    pini = set()
    for open in filter(lambda ijo: ijo not in pini, range(15)):
        lon = nanpa[open]
        sike_ni = [open]
        while lon != open:
            pini.add(lon)
            sike_ni.append(lon)
            lon = nanpa[lon]
        yield sike_ni

def sike_tu(sike):
    for sike_ni in sike:
        pini, *sike_ni = sike_ni
        for nanpa in sike_ni:
            yield (pini, nanpa)
            pini = nanpa

def sike_tu_wan(sike):
    for (a,b) in sike:
        (c,d) = next(sike)
        if a == c:
            yield (a,d,b)
        elif a == d:
            yield (a,c,b)
        elif b == c:
            yield (b,d,a)
        elif b == d:
            yield (b,c,a)
        else:
            yield from [(a,b,c),(b,c,d)]

def sike_wan_i_j(sike):
    for (a,b,c) in sike:
        if a == 0:
            yield (b,c)
        elif b == 0:
            yield (c,a)
        elif c == 0:
            yield (a,b)
        else:
            yield from [(a,b),(b,c)]

def sike_wan_tu_i(sike):
    for (i,j) in sike:
        if i == 1:
            yield j
        elif j == 1:
            yield from [i,i]
        else:
            yield from [j,j,i,j]

def musi(nanpa):
    # nanpa ala li tawa leko pini
    nasin = [3, 2, 1, 0, 4, 5, 6, 7, 11, 10, 9, 8, 12, 13, 14, 15]
    open = "RRRULLLURRRULLL"[nasin.index(nanpa.index(0)):]
    nanpa = [nanpa[i] for i in nasin]
    nanpa = [nasin[nanpa-1] for nanpa in nanpa if nanpa]

    # o pali e sike ante
    sike = sike_ante(nanpa)
    
    # o pali e sike pi nanpa tu
    sike = sike_tu(sike)

    # o ante tawa sike pi nanpa tu wan
    sike = sike_tu_wan(sike)

    # o ante tawa sike sama (0 i j)
    sike = sike_wan_i_j(sike)

    # o ante tawa sike sama (0 1 i)
    sike = sike_wan_tu_i(sike)

    # o ante tawa tawa leko
    lipu_leko = {
        2: "DRRDDLURULLDRDLUUU",
        3: "DRRDDRULDLURRDLUULLDRDLUUU",
        4: "DRRDRDLLURDRULULLDRDLUUU",
        5: "RDDRULLDRDLUURRDLUUL",
        6: "DDRDLUUU",
        7: "RDDDLURUUL",
        8: "RDDLURDDLURULDRUUL",
        9: "DRDLURDDLUURDLUU",
        10: "RDRDLULDRDLUURDRULUL",
        11: "DRDDRUURDLLURDLULDRRRULDDLLUUU",
        12: "RRRDLULDRDLULDRDLUURDRULURDRULLL",
        13: "RRDLULDRDLURDDLUURDLUURDRULL",
        14: "RDLURDDLURDDLUURDLUURDLU"
    }
    pali = ""
    for i in sike:
        pali = lipu_leko[i] + pali

    # o weka e tawa ike
    for tawa in lipu_leko.values():
        pali = pali.replace(tawa*2 , tawa[::-1].translate({68:85,85:68,76:82,82:76}))
    while "UD" in pali or "DU" in pali or "LR" in pali or "RL" in pali:
        pali = pali.replace("UD", "").replace("DU", "") \
                   .replace("LR", "").replace("RL", "")

    return open + pali
