LIST ChangeOp = KeepOld, Replace
LIST Square = One = 1, Two, Three, Four, Five, Six, Seven, Eight, Nine, Ten, Eleven, Twelve, Thirteen, Fourteen, Fifteen, Empty
VAR one = One
VAR two = Two
VAR three = Three
VAR four = Four
VAR five = Five
VAR six = Six
VAR seven = Seven
VAR eight = Eight
VAR nine = Nine
VAR ten = Ten
VAR eleven = Eleven
VAR twelve = Twelve
VAR thirteen = Thirteen
VAR fourteen = Fourteen
VAR fifteen = Fifteen
VAR empty = Empty

😿💔
🔀🤷
🥺
👉👈
↕️↔️

->setup(LIST_ALL(One))->
-> turn

=== turn ===
1️⃣: {pretty(one)} {pretty(two)} {pretty(three)} {pretty(four)}
2️⃣: {pretty(five)} {pretty(six)} {pretty(seven)} {pretty(eight)}
3️⃣: {pretty(nine)} {pretty(ten)} {pretty(eleven)} {pretty(twelve)}
4️⃣: {pretty(thirteen)} {pretty(fourteen)} {pretty(fifteen)} {pretty(empty)}

{checkSolved(LIST_ALL(One)):
🥳 🫴{swapSquares} -> END
- else: 🫵🤔
}

+ {inBounds(-4)} 👆 ->swapSquares(-4)->
+ {inBounds(4)} 👇 ->swapSquares(4)->
+ {inBounds(-1)} 👈 ->swapSquares(-1)->
+ {inBounds(1)} 👉 ->swapSquares(1)->
* -> error
- <> 🥺
-> turn

= error
🤯
-> END

= swapSquares(offset)
~ temp start = findEmpty(LIST_ALL(One))
~ temp end = start + offset
~ do(start, Replace + do(end, Replace + do(start, KeepOld)))
->->

=== function deserializeState(str, index) ===
~ temp start = initPattern(str, index)
{
- str ? start + "_":
~ return Empty
- str ? start + "15":
~ return Fifteen
- str ? start + "14":
~ return Fourteen
- str ? start + "13":
~ return Thirteen
- str ? start + "12":
~ return Twelve
- str ? start + "11":
~ return Eleven
- str ? start + "10":
~ return Ten
- str ? start + "9":
~ return Nine
- str ? start + "8":
~ return Eight
- str ? start + "7":
~ return Seven
- str ? start + "6":
~ return Six
- str ? start + "5":
~ return Five
- str ? start + "4":
~ return Four
- str ? start + "3":
~ return Three
- str ? start + "2":
~ return Two
- str ? start + "1":
~ return One
- else:
~ return ()
}


=== function patternFromSquare(square) ===
{square == Empty:
~ return "_ "
- else:
~ return "{LIST_VALUE(square)} "
}

=== function initPattern(str, index) ===
{index == 0:
~ return "^"
}
~ return initPattern(str, index-1) + "{patternFromSquare(deserializeState(str, index-1))}"

=== function pretty(square) ===
{square:
- One:
~ return "[01]"
- Two:
~ return "[02]"
- Three:
~ return "[03]"
- Four:
~ return "[04]"
- Five:
~ return "[05]"
- Six:
~ return "[06]"
- Seven:
~ return "[07]"
- Eight:
~ return "[08]"
- Nine:
~ return "[09]"
- Ten:
~ return "[10]"
- Eleven:
~ return "[11]"
- Twelve:
~ return "[12]"
- Thirteen:
~ return "[13]"
- Fourteen:
~ return "[14]"
- Fifteen:
~ return "[15]"
- Empty:
~ return "[__]"
- else:
~ return "[??]"
}

=== function do(target, op) ===
{target:
- One:
~ return on(one, op)
- Two:
~ return on(two, op)
- Three:
~ return on(three, op)
- Four:
~ return on(four, op)
- Five:
~ return on(five, op)
- Six:
~ return on(six, op)
- Seven:
~ return on(seven, op)
- Eight:
~ return on(eight, op)
- Nine:
~ return on(nine, op)
- Ten:
~ return on(ten, op)
- Eleven:
~ return on(eleven, op)
- Twelve:
~ return on(twelve, op)
- Thirteen:
~ return on(thirteen, op)
- Fourteen:
~ return on(fourteen, op)
- Fifteen:
~ return on(fifteen, op)
- Empty:
~ return on(empty, op)
- else:
~ return ()
}

=== function on(ref variable, op) ===
~ temp copy = variable
{op ? KeepOld:
~ return variable
}
~ variable = op - Replace
~ return copy

=== function checkSolved(list) ===
{list == ():
~ return true
}
~ temp square = pop(list)
{do(square, KeepOld) == square:
~ return checkSolved(list)
}
~ return false

=== function findEmpty(list) ===
{list == ():
~ return ()
}
~ temp square = pop(list)
{do(square, KeepOld) == Empty:
~ return square
}
~ return findEmpty(list)

=== function inBounds(offset) ===
~ temp square = findEmpty(LIST_ALL(One))
{square + (square + offset):
- (Four, Five):
- (Eight, Nine):
- (Twelve, Thirteen):
- else:
~ return square + offset
}

=== setup(list) ===
{list == ():
->->
}
~ temp square = pop(list)
~ do(square, Replace + deserializeState("^{input()}$", LIST_VALUE(square) - 1))
->setup(list)->->

=== function pop(ref _list) 
    ~ temp el = LIST_RANDOM(_list) 
    ~ _list -= el
    ~ return el 

EXTERNAL input()

=== function input() ===
// fallback
~ return "_ 2 3 4 1 6 7 8 5 10 11 12 9 13 14 15"